﻿using System;
using System.Collections.Generic;
using System.Data.OleDb;
using System.Diagnostics.Eventing.Reader;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Forms;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml.Linq;
using MessageBox = System.Windows.Forms.MessageBox;

namespace AutoUa
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        public string ApiKey;

        public string GetTranslatedText(string strTextToTranslate, string strFromLang, string strToLang)
        {
            string strTranslation;

            if (strFromLang != strToLang)
            {
                string strUri = "https://translate.yandex.net/api/v1.5/tr/translate?key=" + ApiKey + "&text=" + strTextToTranslate + "&lang=" + strFromLang + "-" + strToLang + "&format=plain";

                var request = (HttpWebRequest)WebRequest.Create(strUri);

                //try
                //{
                    WebResponse response = request.GetResponse();
                    Stream strm = response.GetResponseStream();
                    var sr = new StreamReader(strm);
                    strTranslation = sr.ReadToEnd();

                    response.Close();
                    sr.Close();
                //}
                //catch (Exception ex)
                //{
                    //MessageBox.Show("Ensure that you are connected to the internet.",
                    //            "Translator", MessageBoxButton.OK, MessageBoxImage.Stop);
                    //MsgBox.MsgBox.Show(ex.Message, "Translator", MessageBoxButton.OK, MessageBoxImage.Stop);
                //    return (string.Empty);
                //}
            }
            else
            {
                //MessageBox.Show("Translator",
                 //           MessageBoxButton.OK, MessageBoxImage.Exclamation);
                return (string.Empty);
            }

            // Parse string into an XElement and get the XElement Value
            // which is returned as the translated text.
            return (XElement.Parse(strTranslation).Value);
        }

        public string TranslateText(string strText)
        {
            return GetTranslatedText(strText.Replace(" ", @"%20").Replace(@"#", @"%23"), "ru", "uk");
        }

        public void ProcessFile(string strFileName)
        {
            string strFullFileNameToRead = OldTextBox.Text + @"\" + strFileName;
            string strFullFileNameToWrite = NewTextBox.Text + @"\" + strFileName;
            
            var fReader = new StreamReader(strFullFileNameToRead);
            var fWriter = new StreamWriter(strFullFileNameToWrite);

            while (!fReader.EndOfStream)
            {
                string strData = fReader.ReadLine();
                string[] aData = strData.Split(new[] {'|'});
                string strNewText = TranslateText(aData[1]);
                fWriter.WriteLine(aData[0] + "|" + strNewText);
            }

            fReader.Close();
            fWriter.Close();
        }

        //NEW:
        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            //if (textBox1.Text.Trim() == "") textBox1.Text = Environment.CurrentDirectory;
            //if (textBox2.Text.Trim() == "") textBox2.Text = Environment.CurrentDirectory;
            var folderBrowseDialog = new FolderBrowserDialog
            {
                ShowNewFolderButton = false
            };

            if (Directory.Exists(NewTextBox.Text))
                folderBrowseDialog.SelectedPath = NewTextBox.Text;

            if (folderBrowseDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                NewTextBox.Text = folderBrowseDialog.SelectedPath;
            }
        }

        //OLD:
        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            var folderBrowseDialog = new FolderBrowserDialog
            {
                ShowNewFolderButton = false
            };

            if (Directory.Exists(OldTextBox.Text))
                folderBrowseDialog.SelectedPath = OldTextBox.Text;

            if (folderBrowseDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                OldTextBox.Text = folderBrowseDialog.SelectedPath;
            }
        }

        //Start:
        private void Button_Click_3(object sender, RoutedEventArgs e)
        {
            NewTextBox.Dispatcher.Invoke(
                delegate { if (NewTextBox.Text.Trim() == "") NewTextBox.Text = Environment.CurrentDirectory; });

            OldTextBox.Dispatcher.Invoke(
                delegate { if (OldTextBox.Text.Trim() == "") OldTextBox.Text = Environment.CurrentDirectory; });

			ApiKey = KeyTextBox.Text;

            ProcessFile("dialogs.csv");
            ProcessFile("game_menus.csv");
            ProcessFile("game_strings.csv");
            ProcessFile("info_pages.csv");
            ProcessFile("item_kinds.csv");
            ProcessFile("quick_strings.csv");
            ProcessFile("skills.csv");
            ProcessFile("skins.csv");
            ProcessFile("ui.csv");
        }
    }
}
